require "spec_helper"

describe MessageExchange::Put do
  subject { described_class.new('http://www.myurl.woo') }

  it "makes a request to a URL" do
    stub_request(:put, "http://www.myurl.woo/").
      with(:headers => {'Accept'=>'application/json'})

    subject.response
  end

  it "returns a ServerErrorResponse when the request times out" do
    Net::HTTP.stub(:new){ raise Timeout::Error }

    expect(subject.response).to be_a MessageExchange::ServerErrorResponse
  end
end
